<?php
class Minute_model extends CI_Model {

  function Minute_model()
  {
    parent::__construct();
	$this->load->database('default', true);
  }

  function getPower ($begin, $end, $channelid, $limit = 0)
  {
    $this->db->select('kwh, watt, cost, date');
    $this->db->where("date BETWEEN ".$this->db->escape($begin)." AND ".$this->db->escape($end)." ");
    $this->db->where("channel_id",$channelid);
    $this->db->order_by("minute_id", "desc");
    if($limit == 1)
    {
      $this->db->limit(1);
    }
    $query = $this->db->get('minutedata');
    
    return $query;
  }
  
  function getWatts ($beginDate, $now, $limit, $channels, $chQry = "")
  {

    $sql = "SELECT watt, channel_name, gd.channel_id as chid, colour
            FROM minutedata gd INNER JOIN channel chn on gd.channel_id = chn.channel_id,
             (SELECT max(minute_id) as b
              FROM minutedata
              WHERE date BETWEEN ".$this->db->escape($beginDate)." AND ".$this->db->escape($now);

        if($channels != 0)
        {
  
                $x = TRUE;
                foreach($chQry->result() as $channel)
                {
                        if($x)
                        {
                                $sql .= "AND (channel_id = ".$channel->channel_id;
                                $x = FALSE;
                        }
                        $sql .= " OR channel_id = ".$channel->channel_id;
                }

                $sql .= ") ";
        }

        $sql .= " GROUP BY channel_id) AS tbl2
            WHERE gd.minute_id = tbl2.b AND pulse = 0
           ORDER BY watt DESC";

        if($limit)
        {
                $sql .= " LIMIT 10;";
        }

    return $this->db->query($sql);
  }
  
  function getWattNow($device_id, $start, $end)
  {
  	 $sql = "SELECT channel.channel_id, channel.channel_name, channel.chnum, max(date) as date, watt, type, colour
			FROM minutedata
			INNER JOIN channel ON channel.channel_id = minutedata.channel_id
			INNER JOIN devices ON channel.device_id = devices.device_id
			WHERE devices.device_id = ".$device_id."
			AND date between '".$start."' and '".$end."'
			GROUP BY channel.channel_id
			ORDER BY ctype, date desc, watt desc;";
			
    return $this->db->query($sql);
  }
  
  
  function GetMinute($channel_id, $date)
  {
  	$this->db->select('watt');
	$this->db->where('channel_id', $channel_id);
	$this->db->where('date =', $date);
	return $this->db->get('minutedata');
  }
  
  function getMostActive($begin, $end)
  {	
	$this->db->select('sum(kwh) as kwh, channel_name, channel.channel_id as channel_id');
    $this->db->join('minutedata', 'minutedata.channel_id = channel.channel_id', 'inner');  
    $this->db->where("date BETWEEN ".$this->db->escape($begin)." AND ".$this->db->escape($end)." ");
	$this->db->where('main',0);
	$this->db->where('pulse',0);
	$this->db->group_by('channel.channel_id, channel.channel_name');
	$this->db->order_by('kwh', 'DESC');
    return $this->db->get('channel', 10);
  }
  
  function getReadingsForLog($date, $devid, $ctype = 0)
  {
    $this->db->select('wattsecond, seconds, date, channel.channel_id, channel.pulse');
	$this->db->from('minutedata');
	$this->db->join('channel', 'minutedata.channel_id = channel.channel_id');
    $this->db->where('date', $date);
    $this->db->where('channel.device_id', $devid);
    $this->db->where('channel.ctype', "0");
    $this->db->where('channel.netchannel_id', "0");
    $this->db->order_by('channel.chnum', 'ASC');
    return $this->db->get();
  }
  
  
  function getLastChannels($channels, $startDate, $endDate)
  {
  	 $sql = "select * from minutedata INNER JOIN ( SELECT channel_id, max(date) 
  	 as latest_date FROM minutedata where date between '".$startDate."' 
  	 AND '".$endDate."'  
  	 GROUP BY channel_id) dates ON minutedata.channel_id =
  	  dates.channel_id AND minutedata.date = dates.latest_date
	  INNER JOIN channel ON minutedata.channel_id = channel.channel_id
	  WHERE minutedata.channel_id = ";
	  
	  $first = TRUE;
	  foreach($channels->result() as $channel)
	  {
	  	if(!$first)
	  	{
	  		$sql .= ' OR minutedata.channel_id = ';
	  	}
		else {
			$first = FALSE;
		}
	  	$sql .= $channel->channel_id;
	  }

	  $sql .= " ORDER BY minutedata.channel_id ASC;";
	  return $this->db->query($sql); 
  }
  
  function getLastMinute($channel_id, $date)
  {
  	if($channel_id == 0)
	{
	    $this->load->model('channels_model');
	    $mains = $this->channels_model->getMain();
		$x = 1;
	    foreach($mains->result() as $main)
	    {
	      if($x == 1)
	      {
	        $where = '(channel_id = '.$this->db->escape($main->channel_id);
	        $x = 0;
	      }
	      else
	      {
	        $where .= ' OR channel_id = '.$this->db->escape($main->channel_id);
	      }
	    }
	    
	    $where .= ')';
	    
	    $this->db->where($where, NULL, FALSE);
	}
	else
	{
		$this->db->where('channel_id', $channel_id);
	}
  	$this->db->select('wattsecond, seconds, date');
	$this->db->where('date <=', $date);
	$this->db->order_by('date', 'DESC');
	return $this->db->get('minutedata',1);
  }

  function chkMinute($channel_id, $limit = 1)
  {
  	$this->db->select('wattsecond, seconds, date');
  	$this->db->where('channel_id', $channel_id);
	$this->db->order_by('date', 'DESC');
	return $this->db->get('minutedata',$limit);
  }
  
  function getFirstMinute($channel_id, $date)
  {
  	if($channel_id == 0)
	{
	    $this->load->model('channels_model');
	    $mains = $this->channels_model->getMain();
		$x = 1;
	    foreach($mains->result() as $main)
	    {
	      if($x == 1)
	      {
	        $where = '(channel_id = '.$this->db->escape($main->channel_id);
	        $x = 0; 
	      }
	      else
	      {
	        $where .= ' OR channel_id = '.$this->db->escape($main->channel_id);
	      }
	    }
	    
	    $where .= ')';
	    
	    $this->db->where($where, NULL, FALSE);
	}
	else
	{
		$this->db->where('channel_id', $channel_id);
	}
  	$this->db->select('wattsecond, seconds, date');
	$this->db->where('date >=', $date);
	$this->db->order_by('date', 'ASC');

	return $this->db->get('minutedata',1);
  }
  
  function getSumPower ($begin, $end, $channelid)
  {
    $this->db->select('sum(kwh) as kwh, avg(kwh) as tmp, avg(watt) as watt, sum(totalcost) as totalcost, min(watt) as minwatt, max(watt) as maxwatt');
    $this->db->join('channel', 'channel.channel_id = minutedata.channel_id', 'inner');  
    $this->db->where("channel.channel_id",$channelid);
    $this->db->where("date BETWEEN ".$this->db->escape($begin)." AND ".$this->db->escape($end)." ");
    return $this->db->get('minutedata');
  }  
  
  function GetSumPowerReal ($begin, $end, $device_id)
  {
    $this->db->select('channel.channel_id, channel.chnum, channel.colour, channel.ctype, channel.channel_name, sum(kwh) as kwh, avg(kwh) as tmp, avg(watt) as watt, sum(totalcost) as totalcost, min(watt) as minwatt, max(watt) as maxwatt');
    $this->db->join('channel', 'channel.channel_id = minutedata.channel_id', 'inner');  
    $this->db->where("channel.device_id",$device_id);
    $this->db->where("date BETWEEN ".$this->db->escape($begin)." AND ".$this->db->escape($end)." ");
	$this->db->group_by('channel.channel_id');
    return $this->db->get('minutedata');
  }
  
  function getSumForward ($channelid, $date)
  {
    $this->db->select('sum(kwh) as kwh, avg(kwh) as tmp, avg(watt) as watt, sum(totalcost) as totalcost, min(watt) as minWatt, max(watt) as maxWatt');
    $this->db->join('channel', 'channel.channel_id = minutedata.channel_id', 'inner');  
    $this->db->where("channel.channel_id",$channelid);
    $this->db->where("date >=",$date);
    return $this->db->get('minutedata');
  } 
  
  
  function getTempVals ($begin, $end, $channelid)
  {
    $this->db->select('avg(kwh) as kwh, avg(kwh) as watt, sum(totalcost) as totalcost, min(kwh) as minwatt, max(kwh) as maxwatt');
    $this->db->join('channel', 'channel.channel_id = minutedata.channel_id', 'inner');  
    $this->db->where("channel.channel_id",$channelid);
    $this->db->where("date BETWEEN ".$this->db->escape($begin)." AND ".$this->db->escape($end)." ");
    return $this->db->get('minutedata');
  }  
  
  function getKwhColumn ($begin, $end, $channels, $groups = 0)
  {
  	$first = TRUE;
	$sql = 'SELECT channel_name, colour, kwh, ctype FROM (';
  	foreach($channels->result() as $channel)
	{
		if(!$first)
		{
			$sql .= ' UNION ALL ';
		}
		else
		{
			$first = FALSE;
		}
		
		$sql .= "SELECT channel.channel_name, sum(kwh) as kwh, channel.colour, channel.ctype
				FROM minutedata 
				INNER JOIN channel ON channel.channel_id = minutedata.channel_id
				WHERE date BETWEEN ".$this->db->escape($begin)." AND ".$this->db->escape($end)."
				AND channel.channel_id = ".$channel->channel_id."
				GROUP BY channel.channel_name, channel.colour, channel.ctype";
	}
	
	$sql .= ') tbl ORDER BY kwh DESC';

    $query = $this->db->query($sql);
    return $query;
  }   
  
  function checkNegatives ($begin, $end, $channels, $groups, $limit = 0)
  {
    $first = TRUE;
	$sql = 'SELECT channel_name, colour, watt FROM (';
  	foreach($channels->result() as $channel)
	{
		if(!$first)
		{
			$sql .= ' UNION ALL ';
		}
		else
		{
			$first = FALSE;
		}
		
		$sql .= "SELECT channel_name, watt, colour
				FROM minutedata 
				INNER JOIN channel ON channel.channel_id = minutedata.channel_id
				WHERE date BETWEEN ".$this->db->escape($begin)." AND ".$this->db->escape($end)."
				AND channel.channel_id = ".$channel->channel_id."
				ORDER BY date DESC LIMIT 1";
	}
	
	$sql .= ') tbl WHERE watt < 0 ORDER BY watt DESC';
	
	if($limit == 1)
	{
		$sql .= ' LIMIT 10';
	}

    $query = $this->db->query($sql);
	
    return $query;
  }

  function getAvgTemp ($begin, $end, $channelid)
  {
    $this->db->select('avg(watt) as watt');
    $this->db->join('channel', 'channel.channel_id = minutedata.channel_id', 'inner');  
    $this->db->where("channel.channel_id",$channelid);
    $this->db->where("date BETWEEN ".$this->db->escape($begin)." AND ".$this->db->escape($end)." ");
    $query = $this->db->get('minutedata');
    return $query->row_array();
  }  
  
  function getSumKwh ($begin, $end, $channelid)
  {
    $this->db->select('sum(kwh) as kwh');
    $this->db->where("channel_id",$channelid);
    $this->db->where("date BETWEEN ".$this->db->escape($begin)." AND ".$this->db->escape($end)." ");
    return $this->db->get('minutedata');
  }  
  
  function getMainPower($begin, $end)
  {
  	$this->db->select('sum(kwh) as kwh, avg(watt) as watt, sum(totalcost) as totalcost, min(watt) as minwatt, max(watt) as maxwatt');
    $this->db->join('channel', 'channel.channel_id = minutedata.channel_id', 'inner');  
    $this->db->where("date BETWEEN ".$this->db->escape($begin)." AND ".$this->db->escape($end)." ");
	$this->db->where('main',1);
    return $this->db->get('minutedata');
  }
  
  function getReading ($chid, $date)
  {
    $this->db->select('wattsecond, seconds, date');
    $this->db->where('date <=', $date);
    $this->db->where('channel_id', $chid);
    $this->db->order_by('date','desc');
    $this->db->limit(1);
    return $this->db->get('minutedata');
  }
  
  function insertMinute ($ws, $watt, $kwh, $sec, $totCost, $chid)
  {
    $date = gmdate('Y-m-d H:i:00');
	
	$this->db->select('minute_id');
    $this->db->where('date', $date);
    $this->db->where('channel_id', $chid);
    $query = $this->db->get('minutedata');    
    $return = 0;
	
    if($query->num_rows() == 0)
	{
      $data = array(
               'channel_id' => $chid ,
               'date' => $date ,
               'wattsecond' => $ws,
               'watt' => $watt,
               'kwh' => $kwh,
               'seconds' => $sec,
               'totalcost' => $totCost
            );
            
      $this->db->insert('minutedata', $data);    
      $return = 1;
	}
	

	return $return;
  }
  
  function graphLoad($cid, $begin, $end)
  {
  	$sql = "SELECT channel_name, min(ctype) as ctype, min(kwh) as kwh, min(watt) as watt, date
				FROM minutedata 
				INNER JOIN channel ON channel.channel_id = minutedata.channel_id
				WHERE date BETWEEN ".$this->db->escape($begin)." AND ".$this->db->escape($end)."
				AND minutedata.channel_id = ".$this->db->escape($cid)." 
				GROUP BY date, channel.channel_id, channel_name
				ORDER BY channel.channel_id, date ASC";
	
    return $this->db->query($sql);
  }
  
  function graphLine($channels, $begin, $end)
  {
  	$first = TRUE;
	$sql = "SELECT channel_name, min(ctype) as ctype, min(kwh) as kwh, min(watt) as watt, date
				FROM minutedata 
				INNER JOIN channel ON channel.channel_id = minutedata.channel_id
				WHERE date BETWEEN ".$this->db->escape($begin)." AND ".$this->db->escape($end)."
				AND (";
  	foreach($channels->result() as $channel)
	{
		if(!$first)
		{
			$sql .= ' OR ';
		}
		else
		{
			$first = FALSE;
		}
		
		$sql .= "minutedata.channel_id = ".$channel->channel_id;
				
	}
	$sql .= ") GROUP BY date, channel.channel_id, channel_name
				ORDER BY channel.channel_id, date ASC";

    return $this->db->query($sql);
  }
  
  function graphMain($begin, $end)
  {
    $this->load->model('channels_model');
    $mains = $this->channels_model->getMain();
    $first = TRUE;
	$sql = "SELECT sum(watt) as watt, strftime('%Y-%m-%d %H:%M:00', date) as date FROM (";
	foreach($mains->result() as $channel)
	{
		if($first == FALSE)
		{
			$sql .= " UNION ALL ";
		}
		else
		{
			$first = FALSE;
		}
		$sql .= 'select min(watt) as watt, date from minutedata where channel_id = '.$this->db->escape($channel->channel_id).' and date BETWEEN '.$this->db->escape($begin).' AND '.$this->db->escape($end).' group by date';
	}
	$sql .= ") tbl GROUP BY strftime('%Y-%m-%d %H:%M:00', date) ORDER BY date asc;";
	
    $query = $this->db->query($sql);
	
    return $query;
  }
  
  function getWattPeriod($cid, $begin, $end)
  {
    $this->db->select('max(wattsecond) as maxws', FALSE);
    
    $this->db->select('min(wattsecond) as minws', FALSE);
    
    $this->db->select('max(watt) as maxwatt', FALSE);
    $this->db->select('max(watt) as minwatt', FALSE);
    $this->db->where("date BETWEEN ".$this->db->escape($begin)." AND ".$this->db->escape($end)." ");
    $this->db->where("channel_id",$channelid);
    $query = $this->db->get('minutedata');

    return $query;
  }

  function getRecent($chid, $begin, $end)
  {
     $this->db->select('date,watt,kwh', FALSE);
     $this->db->where('channel_id', $chid);
     $this->db->where("date BETWEEN ".$this->db->escape($begin)." AND ".$this->db->escape($end)." ");
     $this->db->order_by('minutedata.date','DESC');
     return $this->db->get('minutedata',1);
  }
  
  function getLastReading($chid, $date = 0)
  {
     $this->db->select('date,watt,kwh', FALSE);
     $this->db->where('channel_id', $chid);
	 if($date != 0)
	 {
	 	$this->db->where('date >', $date);
	 }
     $this->db->order_by('date','DESC');
     return $this->db->get('minutedata',1);
  }
  
  function getTotalCost ($begin, $end, $channels, $groups = 0)
  {
  	$first = TRUE;
	$sql = 'SELECT channel_name, colour, totalcost FROM (';
  	foreach($channels->result() as $channel)
	{
		if(!$first)
		{
			$sql .= ' UNION ALL ';
		}
		else
		{
			$first = FALSE;
		}
		
		$sql .= "(SELECT channel.channel_name, sum(totalcost) as totalcost, channel.colour
				FROM minutedata 
				INNER JOIN channel ON channel.channel_id = minutedata.channel_id
				WHERE date BETWEEN ".$this->db->escape($begin)." AND ".$this->db->escape($end)."
				AND channel.channel_id = ".$channel->channel_id."
				GROUP BY channel.channel_name, channel.colour)";
	}
		
	$sql .= ') tbl ORDER BY totalcost DESC';

    $query = $this->db->query($sql);
    return $query;
  }
  
  function ClearData()
  {
  	$this->db->truncate('minutedata');
  }
  
  function _getMinutes($sStartDate, $sEndDate){  

  $sStartDate = date("Y-m-d H:i:00", strtotime($sStartDate));  
  $sEndDate = date("Y-m-d H:i:00", strtotime($sEndDate));  
  $sCurrentDate = $sStartDate;  
  while($sCurrentDate < $sEndDate){  

    $sCurrentDate = date("Y-m-d H:i:00", strtotime("+1 minutes", strtotime($sCurrentDate)));  
  
    // Add this new day to the aDays array  
    $aDays[] = $sCurrentDate;  
  } 
  
  // Once the loop has finished, return the  
  // array of days.  
    return $aDays;  
  }  
}
?>